 package Out100;

################################################################
###                                                          ###
### SCaFoS                                                   ###
### Ecriture des fichiers de sortie                          ###
###                                                          ###
################################################################
### version 1.00 du 2006/03/08                           BPH ###
################################################################


 use strict;
 use warnings;
 use Cwd;
 use Tk;
 use Tk::TextUndo;

 use Var100;
 use Lib100;
 use Gub100;
 
 use vars qw(@ISA @EXPORT);
 require Exporter;
 @ISA = qw(Exporter);
 @EXPORT = qw/ WriteConcat WriteMissing StatMissingGrp WriteStat /;

 
################################################################


 my $bAff = '';       # texte pour affichage en mode graphique
 my $L;
 my $bResult;
 my $buf;
 my %hLength;         # Nombre de caracteres par sequence concatenee
 
################################################################


### GESTION DES CONCATENATIONS ET DES SOUS_REPERTOIRES #########
sub WriteConcat {
    ($bResult) = @_;    
    my @lSpe;
    my ($fMB, $fPAUP);
        
    if ( $FlagIHM == 1 ) { ViewCurrent('Writing of concatenated file', 'darkblue', $Current ); }
    
    #-- Lecture de l'ordre des groupes dans .otu ---------------
    if ( $FlagAlphabet == 0 )
        { @lSpe = ReadSpeToOrder(); }
    else
        { @lSpe = sort keys %hConcat; }   
    
    ($L, $fMB, $fPAUP) = WriteInFormat($NameCef, 1, @lSpe);
        
    ### Concatenation dans les sous-repertoires partiels ###
    if ( $SpecFile ne '' ) {
        if ( $FlagMisGrp == 1 ) { 
            if ( $FlagIHM == 1 ) { ViewCurrent('Writing of concatenated files in subdirectories', 'darkblue', $Current ); }
            ConcatSubDir_Gene();
            }
        }
            
    $L = "\n\n\n=======================================================================";
    $L .= "\n\n RESULTS";
    $buf = '';
    if ( $FlagFasta == 1 ) { 
        $buf = "\'$NameCef.fasta\'";
        if ( $FlagNexus == 1 or $FlagPHYLIP == 1 or $FlagMust == 1 ) { $buf .= " and "; }
        }
    if ( $FlagMust == 1 ) { 
        $buf = "\'$NameCef.ali\'";
        if ( $FlagNexus == 1 or $FlagPHYLIP == 1 ) { $buf .= " and "; }
        }
    if ( $FlagPHYLIP == 1 ) { 
        $buf .= "\'$NameCef.phylip\'";
        if ( $FlagNexus == 1 ) { $buf .= " and "; }
        }
    if ( $fMB == 1 ) { 
        $buf .= "\'".$NameCef. "_MB.nex\'";
        if ( $FlagPAUP == 1 or $FlagOther == 1 ) { $buf .= " and "; }
        }
    if ( $fPAUP == 1 ) { 
        $buf .= "\'".$NameCef. "_PAUP.nex\'";
        if ( $FlagOther == 1 ) { $buf .= " and "; }
        }
    if ( $FlagOther == 1 ) { $buf .= "\'".$NameCef. ".nex\'"; }
    elsif ( $fMB == 0 and $fPAUP == 0 and $FlagNexus == 1 ) { $buf .= "\'".$NameCef. ".nex\'"; }
    $L .= "\n\n   The concatenations are in file(s) : $buf";
    $bResult = $L . $bResult;
    if ( $FlagIHM == 1 ) { ViewDetails("$L\n\n", 0); }
    else { print "$L\n\n"; }
    if ( $fMB == 1 ) { $FlagNexus = 0; $FlagMB = 1; }
    if ( $fPAUP == 1 ) { $FlagNexus = 0; $FlagPAUP = 1; }
}    


### ECRITURE DES CONCATENATIONS AU FORMAT CHOISI ###############
sub WriteInFormat {
    my ($NameCat, $flagAdd, @lSpe) = @_;
    my $FlagType = '';
    my ($bName, $bSeq, $bCat, $LgSeq, $NbSeq);
    my ($NbPart, $bPart, $n, $bGene) = (0, '', 0, '');
    my $E;
    my $SumNbMis = 0;

    #-- au format FASTA ----------------------------------------
    if ( $FlagFasta == 1 ) {
        if ( !open(CAT, "> $NameCat.fasta") ) { AffError("Can't open for writing the file \'$NameCat.fasta\' !"); }
        $SumNbMis = CatFormatTwo(@lSpe);
        close CAT;
        }
    
    #-- au format ALI ------------------------------------------
    if ( $FlagMust == 1 ) {
        if ( !open(CAT, "> $NameCat.ali") )
            { AffError("Can't open for writing the file \'$NameCat.ali\' !"); }
        print CAT "#\n#\n";
        $SumNbMis = CatFormatTwo(@lSpe);
        close CAT;
        }
    
    #-- au format PHYLIP ---------------------------------------
    if ( $FlagPHYLIP == 1 ) { 
        ($FlagType, $bCat, $NbSeq, $LgSeq, $SumNbMis) = CatFormatOne("A10", @lSpe);
        $buf = "$NameCat.phylip";
        if ( !open(CAT, "> $buf") )
            { AffError("Can't open for writing the file \'$buf\' !"); }
        print CAT "$NbSeq $LgSeq\n$bCat\n";
        close CAT;
        }
    
    #-- au format NEXUS ----------------------------------------
    my $fMB = 0;
    my $fPAUP = 0;    
    if ( $FlagNexus == 1 ) {
        ($bCat, $LgSeq, $NbSeq) = ('', 0, 0);
        ($FlagType, $bCat, $NbSeq, $LgSeq, $SumNbMis) = CatFormatOne("A79", @lSpe);
        
        # ecriture du fichier
        if ( $FlagMB == 1 ) { $buf = $NameCat. "_MB.nex"; }
        elsif ( $FlagPAUP == 1 ) { $buf = $NameCat. "_PAUP.nex"; }
        else { $buf = $NameCat. ".nex"; }
        if ( !open(NEX,"> $buf") )
            { AffERror("Can't open for writing the file \'$buf\' !"); }
NEXUS:
        $buf  = "#NEXUS\n\n";
        $buf .= "Begin data;\n";
        $buf .= "    dimensions ntax=$NbSeq nchar=$LgSeq;\n";
        $buf .= "    format datatype=$FlagType gap=- missing=\?;\n";
        $buf .= "    Matrix\n";
        $buf .= $bCat;
        $buf .= "    ;\n";
        $buf .= "End;\n\n";
        print NEX $buf;
        
        if ( $FlagMB == 1 ) {
            ($NbPart, $bPart, $n, $bGene) = (0, '', 0, '');
            # definition des partitions
            $n = 1;
            for ( sort keys %FicLen ) {
                $bPart .= "$n-";
                $n += int($FicLen{$_})-1;
                $bPart .= "$n,";
                $n++;
                $NbPart++;
                $buf = $_;
                $buf =~ s/\.ali//;
                $bGene .= "$buf,";
                }
            if ( $bGene ne '' ) { $bGene = substr($bGene, 0, length($bGene)-1); }
            if ( length($bPart) > 0 ) { $bPart = substr($bPart, 0, length($bPart)-1); }
            $buf  = "begin MrBayes;\n";
            $buf .= "    [genes = $NbPart:$bGene]\n";
            $buf .= "    partition part = $NbPart:$bPart;\n";
            $buf .= "    set partition = part;\n";
            $buf .= "    Lset applyto=(all) aamodel=wag rates=invgamma;\n";
            $buf .= "    unlink shape=(all);\n";
            $buf .= "    unlink pinvar=(all);\n";
            $buf .= "    unlink statefreq=(all);\n";
            $buf .= "    unlink brlens=(all);\n";
            $buf .= "    mcmc ngen=1000 printfreq=100 samplefreq=10 nchains=4 savebrlens=yes;\n";
            $buf .= "end;\n";

            #-- creation fenetre de saisie ---
            if ( ($FlagIHM == 1) and ($flagAdd == 1) ) { 
                close NEX;
                AddInNexus($NameCat. "_MB.nex", $buf); 
                }
            else
                { print NEX $buf; close NEX; }
            $fMB = 1;
            
            if ( $FlagPAUP == 1 ) {
                $FlagMB = 0;
                if ( !open(NEX,"> " . $NameCat. "_PAUP.nex") )
                    { AffError("Can't open for writing the file \'".$NameCat."_PAUP.nex\' !"); }
                goto NEXUS;
                }
                
            elsif ( $FlagOther == 1 ) {
                $FlagMB = 0;
                $buf = $NameCat. ".nex";
                if ( !open(NEX,"> $buf") ) { AffError("Can't open for writing the file \'$buf\' !"); }
                goto NEXUS;
                }
            }
            
        elsif ( $FlagPAUP == 1 ) {
            $buf  = "begin PAUP;\n";
            $buf .= "    log file=".$NameCat."_PAUP.log start replace;\n";
            $buf .= "    set querybeep=no;\n";
            $buf .= "    set notifybeep=no;\n";
            $buf .= "    set monitor=no;\n";
            $buf .= "    set increase=auto;\n";
            $buf .= "    set autoclose=yes;\n";
            $buf .= "    set criterion=parsimony;\n";
            $buf .= "    hsearch addseq=random randomize=addseq nreps=100 rseed=7545489;\n";
            $buf .= "    describetrees /plot=phylogram;\n";
            $buf .= "    log stop;\n";
            $buf .= "    set monitor=yes;\n";
            $buf .= "    savetrees file=out/".$NameCat."_PAUP.tre format=nexus BrLens=yes replace=yes\n";
            $buf .= "end;\n";
            if ( ($FlagIHM == 1) and ($flagAdd == 1) ) { 
                close NEX;
                AddInNexus($NameCat. "_PAUP.nex", $buf); 
                }
            else
                { print NEX $buf; close NEX; }
            $fPAUP = 1;
            
            if ( $FlagOther == 1 ) {
                $FlagPAUP = 0;
                $buf = $NameCat. ".nex";
                if ( !open(NEX,"> $buf") ) { AffError("Can't open for writing the file \'$buf\' !"); }
                goto NEXUS;
                }
            }
            
        elsif ( $FlagOther == 1 ) {
            if ( ($FlagIHM == 1) and ($flagAdd == 1) ) { 
                close NEX;
                AddInNexus($NameCat. ".nex", $buf); 
                }
            else
                { print NEX $buf; close NEX; }
            }
            
        else
            { close NEX; }
        }
    return($SumNbMis, $fMB, $fPAUP);
}


### reformate le hachage des sequences concatenees sur 2 lignes ###
sub CatFormatTwo {
    my (@lSpe) = @_;
    my $NbMis = 0;
    my $SumNbMis = 0;
    my $E;
    
    for $E ( @lSpe ) {
        $NbMis = CountPosMis($hConcat{$E});
        $SumNbMis += $NbMis;
        if ( $FlagLength == 1 ) {
            # ajout nombre total de caracteres dans la concatenation
            $L = sprintf("%.0f", length($hConcat{$E}) - $NbMis);
            print CAT ">$E\@$L\n";
            # ajouter nombre de caracteres a chaque nom
            $hLength{$E} = $L;
            }
        else {
            print CAT ">$E\n";
            }
        # sequence concatenee
        print CAT "$hConcat{$E}\n";
        }
    return($SumNbMis);
}

    
### reformatte le hachage des sequences concatenees sur 1 ligne ###
sub CatFormatOne {
    my ($bFormat, @T) = @_;       
    my ($FlagType, $bName, $bSeq, $bCat, $NbSeq) = ('', '', '', '', 0);
    my %hNom = ();   # { nom -> increment }
    my $n;


    # parcours des sequences concatenees
    my $SumNbMis = 0;
    for ( @T ) {
        # sequences concatenees
        $bSeq = $hConcat{$_};
        # nom du groupe
        $bName = pack($bFormat, $_);
        if ( $FlagPHYLIP == 1 ) {
            # verifie doublons de noms
            if ( $hNom{$bName} ) {
                if ( length($bName) == 10 ) {
                    $n = int($hNom{$bName});
                    $hNom{$bName} = $n + 1;
                    $bName = substr($bName,0,9) . $n;
                    } 
                }
            else
                { $hNom{$bName} = 1; }
            }
        $bName =~ s/\s/_/g;          # remplace espaces par soulignes
        $bSeq =~ s/\.|\$|\*/-/g;           # remplace ., $ ou * par -
        $bSeq =~ s/ |X/\?/g;         # remplace espace ou X par ?
        $bCat .= $bName." $bSeq\n";
        $NbSeq++;
        $SumNbMis += CountPosMis($bSeq);
        if ( $FlagType eq '' ) {
            if ( $bSeq =~ m/[EFILPQ]/ )
                { $FlagType = 'protein'; }
            else
                { $FlagType = 'DNA'; }
            }
        }
    return($FlagType, $bCat, $NbSeq, length($hConcat{$T[0]}), $SumNbMis);
}


### Concatenation des sequences dans sous-repertoires par Nb OTUs absents dans un gene ###
sub ConcatSubDir_Gene (){
    my @VarGlob;        # sauvegarde des variables globales
    my $nbFilePrev = -1;# nombre de fichiers dans le repertoire precedent
    my $LSpe = "";      # liste des groupes d'un fichier
    my $SeqName;
    my $CatFile;
    my $ListEsp = '';
    my $F;
    my $E;
    my $i;
    my $n;
    my $buf;
    my $NbSeq;
    my $SumNbMis;
    
    if ( $FlagVerb == 1 ) {    
        $bAff = "\n=======================================================================\n";
        $bAff .= "\n SUB-DIRECTORIES ACCORDING TO MISSING GROUPS NUMBER\n\n";
        }
    else
        { $bAff = "\n SUB-DIRECTORIES ACCORDING TO MISSING GROUPS NUMBER"; }
    if ( $FlagIHM == 1 ) { ViewDetails($bAff, 0); }
    else { print $bAff; }
            
    #** sauvegarde des variables globales **********************
    $VarGlob[0] = $FileRep;
    $VarGlob[1] = $SpecFile;
    $VarGlob[2] = $NbEspTot;   #nb grp dans le spe initial
    $VarGlob[3] = $NbFileAli;
    my %hFic = %Fichiers;
    my %hFrq = %FreqSpec;
    my @T1;
    @T1 = keys %hStatGrp;
    my $NbGrp = $#T1 + 1;
    my $MisRep;                # sous-repertoire d'ecriture
    
    $buf = $MisGenRep.$SepDir."misgen.stat";
    if ( !open(RES, "> $buf") ) { AffError("\nCan\'t open \'$buf' (1)\n\n"); }
    print RES "#Dir\tNo files\tNo seq\tLength\t% mis.pos\n";

    $FileRep = $MisGenRep."tmp";
    CreateDir($FileRep);

    for ( $i = 0; $i <= $NbMisGrp; $i++ ) {
        #** reinitialisation variables globales ***
        $MisRep = $MisGenRep."misgen_".$i;
        $CatFile = $MisRep.$SepDir."misgen_".$i;
        $SpecFile = $MisRep.$SepDir."misgen_".$i.".otu";
        $NbEspTot = 0;
        $NbFileAli = 0;
        delete @Fichiers{keys %Fichiers};
        delete @FreqSpec{keys %FreqSpec};
        if ( $FlagVerb == 1 ) { 
            $bAff = "    misgen_".$i; 
            if ( $FlagIHM == 1 ) { ViewDetails($bAff, 0); }
            else { print $bAff; }
            }
        
        #** liste les fichiers du sous-repertoire **************
        if ( !opendir(REP, $MisRep) ) { AffError("Can't open the directory \'$MisRep\' !"); }
        if ( $TypeAli eq '.ali' ) { @T1 = grep m/\.ali$/i, readdir REP; }
        elsif ( $TypeAli eq '.fasta' ) { @T1 = grep m/\.fasta$/i, readdir REP; }
        else { @T1 = grep m/\.phylip$/i, readdir REP; }
        closedir REP;
        $NbFileAli = $#T1;
        
        if ( $NbFileAli == $nbFilePrev ) {
            # pas de nouveau fichier dans le repertoire : on supprime le repertoire
            if ( $FlagVerb == 1 ) { 
                $bAff = "  -> remove\n"; 
                if ( $FlagIHM == 1 ) { ViewDetails($bAff, 0); }
                else { print $bAff; }
                }
            if ( $^O eq 'linux' ) { system("rm -fR $MisRep"); }
            else { system("rmdir /S /Q $MisRep"); }
            next;
            }
        else {
            if ( $FlagVerb == 1 ) { 
                $bAff = "  -> concatenate\n"; 
                if ( $FlagIHM == 1 ) { ViewDetails($bAff, 0); }
                else { print $bAff; }
                }
            $nbFilePrev = $#T1;
            if ( !open(LEN, "> ".$MisRep.$SepDir."misgen_$i.len") )
                { AffError("\nCan\'t open \'$MisRep"."/misgen_$i.len\' (1)\n\n"); }
            print LEN "#File\tLength\tNo seq\tNo mis.pos\t% mis.pos\n";
            }
        $NbFileAli += 1;
        
        #** creation nouveau .otu ******************************
        #** determine les groupes du fichier ***
        my @lName;    # liste des noms de groupes
        my $Lg;       # longueur de sequence max dans chaque fichier
        my $nbMis;    # nombre de positions manquantes dans chaque fichier
        my $FileName; # nom du fichier avec extention .ali
        my ($fMB, $fPAUP);
        $SumNbMis = 0;
        my $LgAll = 0;# longueur de la concatenation
        
        foreach $FileName (sort @T1) {        
            @lName = ();
            $nbMis = 0;
            $FileName =~ m/(\d*_)(.*)/;
            if ( $TypeAli eq '.ali' ) { $F = $2; }
            else { $F = $2 . '.ali'; }
            if ( $^O eq 'linux' ) { system("cp -f $MisGenRep$F $FileRep"); }
            else { system("copy /Y $MisGenRep$F $FileRep"); }
            $Lg = $FicLen{$F};
            $LgAll += $Lg;
            if ( !open(FIC, $FileRep.$SepDir.$F) )
                { AffError("Can't open for reading file \'".$FileRep.'/'.$F."\' !"); }
            while ( $L = <FIC> ) {
                if ( $L =~ m/^#(.*)/ ) { next; }
                # recupere le nom du groupe
                $L = EndLine($L);  # gestion des fins de lignes dos/unix
                $SeqName = "";
                if ( $L =~ m/^>(.*)/ ) {
                    $SeqName = $1;
                    push (@lName, $SeqName);
                    if ( !exists($FreqSpec{$SeqName}) ) {  
                        # nouveau groupe
                        $FreqSpec{$SeqName} = 0;
                        $NbEspTot++;
                        }
                    }
                # determine le nombre de sites manquants
                else {
                    $L = pack('A'.$Lg, $L);
                    $nbMis += CountPosMis($L);
                    }
                }
            close FIC;
            #** remplit un hachage de tableaux ***
            #   avec cle = nom du fichier / valeur = tableau des especes
            $Fichiers{$F} = [ sort @lName ];
            #-- met a jour tableau resume du contenu du fichier
            print LEN "$FileName\t".$Lg."\t".scalar(@lName)."\t$nbMis\t";
            $L = sprintf("%0.f\n", ($nbMis * 100)/($Lg*scalar(@lName)));
            print LEN $L;
            }
        close LEN;
        
        #** ecriture du fichier spe ***
        if ( !open(SPE,"> $SpecFile") ) { AffError("Can't open for writing file \'$SpecFile\' !"); }
        print SPE "# List of species (alphabetic order)# Total number of OTUs : " . scalar(keys(%FreqSpec)) . "\n#\n";
        foreach $E ( sort keys %FreqSpec ) {
            # compte nombre apparitions du groupe $E dans l'ensemble des fichiers
            $n = 0;
            foreach $F ( keys %Fichiers ) {
                $ListEsp = "<<<<<" . join("<<<<<", @{$Fichiers{$F}}) . "<<<<<";
                $buf = "<<<<<" . $E . "<<<<<";
                $n++ if ( $ListEsp =~ m/$buf/ );
                }
            $FreqSpec{$E} = $n;
            $L = sprintf("%.0f", (100 * $n) / $NbFileAli);
            print SPE "$E : $E ($L%)\n"; 
            }
        close SPE;

        #** ecriture du fichier de concatenation ***************
        %hConcat = ConcatSeq(1);
        $NbSeq = scalar(keys(%hConcat));
        if ( $NbSeq > 0 ) {
            if ( $FlagAlphabet == 0 )
                { @lName = ReadSpeToOrder(); }
            else
                { @lName = sort keys %hConcat; }
                
            %hLength = ();
            ($SumNbMis, $L, $n) = WriteInFormat($CatFile, 0, @lName);
            # ajouter nombre de caracteres a chaque nom
            if ( $FlagLength == 1 and ($FlagFasta == 1 or $FlagMust == 1) ) { AddLength($MisRep, @T1 ); }
            # decomptes sur la concatenation
            print RES "misgen_$i\t$NbFileAli\t$NbSeq\t$LgAll\t";
            $SumNbMis += ($NbGrp-$NbSeq)*$LgAll;
            print RES sprintf("%0.f", $SumNbMis*100/($NbGrp*$LgAll));
            print RES "\n";
            }
        }
    close RES;
    #-- Suppression des fichier .ali temporaire ----------------
    if ( $^O eq 'linux' ) { 
        system("rm -f ".$MisGenRep.$SepDir."*.ali");
        system("rm -rf $FileRep");
        }
    else { 
        system("del /F /Q ".$MisGenRep.$SepDir."*.ali");
        system("rmdir /S /Q  $FileRep");
        }
    
    #** restauration des variables globales ********************
    $FileRep = $VarGlob[0];
    $SpecFile = $VarGlob[1];
    $NbEspTot = $VarGlob[2];
    $NbFileAli = $VarGlob[3];
    %Fichiers = %hFic;
    %FreqSpec = %hFrq;
}


### Ajoute nombre de caracteres de la concatenation a chaque sequence
sub AddLength {
    my ($MisRep, @lF) = @_;
    my ($F, $L, $bFile);
    
    for $F ( @lF ) {
        if ( !open(FIC, $MisRep.$SepDir.$F) ) {
            $bAff = "Can't open for reading file \'$MisRep/$F\' !";
            if ( $FlagIHM == 1 ) { ViewInfo("Warning", $bAff, 'red'); }
            else { print "   $bAff\n"; }
            }
        else {
            if ( !open(NEW, '> '.$MisRep.$SepDir.'/tmp') ) {
                $bAff = "Can't open for writing file \'".$MisRep."/tmp\' !";
                if ( $FlagIHM == 1 ) { ViewInfo("Warning", $bAff, 'red'); }
                else { print "   $bAff\n"; }
                }
            else {
                # recuperation du fichier
                while ( $L = <FIC> ) {
                    chomp($L);
                    # determine nom de sequence et ajoute nombre de caracteres
                    if ( $L =~ m/^>(.*)$/ )
                        { print NEW $L . '@' . $hLength{$1} . "\n"; }
                    # recrit la ligne telle quelle
                    else
                        { print NEW  "$L\n"; }
                    }
                # reecriture du fichier
                close NEW;
                if ( $^O eq 'linux' ) { 
                    system("rm -f ".$MisRep.$SepDir.$F);
                    system("mv ".$MisRep.$SepDir."tmp ".$MisRep.$SepDir.$F);
                    }
                else {
                    system("rm /S /Q ".$MisRep.$SepDir.$F);
                    system("move -f ".$MisRep.$SepDir."tmp ".$MisRep.$SepDir.$F);
                    }
                }
            close FIC;
            }
        }
}


### Decompte des positions manquantes (?| |X|*|.|-|$) ##########
#sub CountPosMis {
#    my $n = 0;
#    my ($b) = @_;
#    
#    $n++ while ( $b =~ m/\?|\s|\*|\.|\$|-|X/g );
#    return($n);
#}


### Concatenation des sequences ################################
sub ConcatSeq (){
    my ($FlagOne) = @_;
    my $L;
    my $ListEsp = "";   # liste des especes deja dans le fichier de concatenation
    my $LEF;            # liste des especes du fichier traite deja recuperees
    my $E;
    my $seq;
    my $p;
    my $n;
    my $b;
    my $buf;

    %hConcat = ();    
    if ( $FlagOne == 0 ) {     
        if ( !open(LEN, "> $NameCef.len") ) {
            if ( $FlagIHM == 1 ) { ViewInfo("Warning", "Can't open for writing file \'$NameCef.len\' !", 'red'); }
            else { print "   Can't open for writing file \'$NameCef.len\' !"; }
            return -1;
            }
        print LEN "#File\tLength\tNo seq\n";
        }
    
    my ($n1, $n2);
    for my $F ( sort keys %Fichiers ) {    # boucle sur les fichiers
        if ( !open(FIC_ALI, $FileRep.$SepDir.$F) )
            { AffError("Can't open for reading file \'".$FileRep.$SepDir.$F."\' !"); } 
        my @T1 = <FIC_ALI>;                   # recuperation de tout le fichier
        close FIC_ALI;
        my $file = join("", @T1) . ">";   # concatenation de toutes les lignes en une liste
        $file =~ s/\r\n/\|/g;             # remplace fin de ligne par |
        $file =~ s/\n/\|/g;               # remplace \n par |
        my $iSeq = 0;                     # nb de sequences retenues dans le fichier
            
        for $E ( sort keys %FreqSpec ) {  # boucle sur les especes retenues
            pos($file) = 0;
            $p = 0;
            $LEF = "<<<<<";
            $seq = "";
            while ( $file =~ m/>$E/gs ) {
                $b = "";
                # cherche occurence suivante de l'espece
                $p = index($file, ">$E", $p+1);
                if ( $p > -1 ) {
                    $n = index($file, ">", $p+1);      # determine la fin de la sequence
                    $L = index($file, "|", $p+1) + 1;
                    if ( $n == -1 ) { $n = index($file, "|", $L+1); }
                    $b = substr($file, $L, $n - $L - 1);
                    $b = EndLine($b);                  # gestion des fins de lignes dos/unix
                    $b = pack("A".$FicLen{$F}, $b);    # toutes les sequences ont la taille max
                    $b =~ s/\s|\$|X/\?/g;               # remplace ' ', $ et X par ?
                    $b =~ s/-|\./\*/g;                  # remplace - et . par *
                    # le fichier ne contient qu'une seule fois la sequence (cas des groupes)
                    if ( $FlagOne == 1 ) {
                        $seq = $b;
                        $iSeq++;
                        }
                    # le fichier peut contenir plusieurs fois la meme espece : on cherche la plus longue
                    else {
                        # nouvelle espece pour ce fichier : stockage pour unicite espece
                        $buf = "<<<<<" . $E . "<<<<<";
                        if ( !($LEF =~ m/$buf/) ) {
                            $LEF .= $E." <<<<<";
                            $seq = $b;
                            $n2 = 0;
                            $n2++ while ( $b =~ m/\?|\*/g );    # initialise nb de blancs
                            $iSeq++;
                            }
                        # verifie si la nouvelle sequence est plus longue
                        else {
                            $n1 = 0;
                            $n1++ while ( $b =~ m/\?|\*/g );    # compte blancs dans sequence precedente
                            if ( $n1 < $n2 ) { $seq = $b; $n2 = $n1;}
                            }
                        }
                    }
                }
            # espece absente du fichier
            if ( length($seq) == 0 ) { $seq = "?" x $FicLen{$F}; }
            # copie de la sequence la plus longue
            $hConcat{$E} .= $seq;
            }   
        if ( ($FlagOne == 0) and ($iSeq > 0) ) { print LEN "$F\t".$FicLen{$F}."\t$iSeq\n"; }
        }
    if ( $FlagOne == 0 ) { close LEN; }
    return %hConcat;
}


sub WriteMissing {
    my ($F, $NbGrpAbs, $LgFile) = @_;
    my $FileName;
    my $nbE;
    my $nb;
    my $i;
    
    #** Ecrit fichier des sequences extraites dans sous-repertoire **
    $FileName = $F;
    if ( $FlagMisGrp == 1 ) {
        #-- lecture du fichier ---
        $L = $MisGenRep.$F;
        if ( !open(EXT, $L) ) { AffError("Can't open for reading file \'$L\' !"); }
        $buf = "";
        $nbE = 0;
        $nb = 0;
        while ( $L = <EXT> ) {
            if ( $L =~ m/^#/ ) { next; }               # ligne de commentaire
            chomp($L);
            if ( $L eq '' ) { next; }                  # ligne vide
            # nom du groupe
            if ( $L =~ m/^>(.*)/ ) { 
                if ( $TypeAli eq '.phylip' ) { $buf .= "$1 "; }
                else { $buf .= "$L\n" ; }
                }
            # sequence
            else {                                     
                $nb++ while ( $L =~ m/\?|\*|\.|\$|X|-| /g );
                $nbE++;
                $buf .= "$L\n";
                }
            }
        close EXT;
        
        #-- ecriture fichier dans sous-repertoire ---
        if ( $TypeAli ne '.ali' ) { $FileName =~ s/\.ali$//i; }
        $L = $MisGenRep."misgen_".$NbGrpAbs.$SepDir.$NbGrpAbs."_".$FileName;
        open(EXT, "> $L") || die "Can't open for writing the file \'$L\' !";
        if ( !open(EXT, "> $L") ) { AffError("Can't open for writing file \'$L\' !"); }
        if ( $TypeAli eq '.ali' ) { 
            if ( ($nbE > 0) and ($LgFile > 0) ) {
                $i = 100 * $nb/($nbE*$LgFile); 
                print EXT "#Number of positions: $LgFile\n#Number of OTUs: $nbE\n#Percent of ?: $i\n#\n$buf";
                }
            else {                
                print EXT "#Number of positions: $LgFile\n#Number of OTUs: $nbE\n#\n$buf";
                }
            }
        elsif ( $TypeAli eq '.phylip' )
            { print EXT "$nbE $LgFile\n$buf"; }
        else
            { print EXT $buf; }
        close EXT;
        for ( $i=$NbGrpAbs+1; $i<=$NbMisGrp; $i++ ) {
            if ( $^O eq 'linux' ) { system("cp -f $L ".$MisGenRep."misgen_".$i); }
            else { system("copy /Y $L ".$MisGenRep."misgen_".$i); }
            }
        }
    #** Ecrit liste fichiers par nombre de groupes absents **
    $hGrpAbs{$NbGrpAbs} .= "$FileName ";
}    


sub StatMissingGrp {
    if ( !open(MIS, "> $NameCef.misotu") ) {
        if ( $FlagIHM == 1 ) { ViewInfo("Warning", "Can't open for writing file \'$NameCef.misotu\' !", 'red'); }
        else { print "\n\n   Can't open for writing file \'$NameCef.misotu\' !\n\n"; }
        return -1;
        }
    my $Nb;
    my $bGrpAbs = "";
    print MIS "List of files according number of missing OTUs\n";
    for $Nb ( sort keys %hGrpAbs ) {
        print MIS "$Nb : $hGrpAbs{$Nb}\n";
        $bGrpAbs .= "$hGrpAbs{$Nb} ";
        }
    print MIS "\nList of files with less than $NbMisGrp missing OTUs :\n";
    print MIS "$bGrpAbs\n";
    close MIS;
}


### Ecriture d'un tableau synthetique sur l'ensemble de la concatenation ###
sub WriteStat {
    my (@Fic, @Grp, @L);
    my ($Grp, $F, $buf, $NbGrp);
    my ($b1, $b2, $b3, $b4) = ('','','','');
    my $SumLgr = 0;
    my $trous = "";
    my $NbFic;
    my $FileName;
    
    #-- Affichage deroulement ----------------------------------
    if ( $FlagVerb == 1 ) {
        $bAff = "\n\n=======================================================================\n";
        $bAff .= "\n WRITING OF STATISTICAL FILES\n";
        }
    else
        { $bAff = "\n WRITING OF STATISTICAL FILES\n"; }
    if ( $FlagIHM == 1 ) {
        ViewCurrent( 'Writing of statistical files', 'darkblue', $Current );
####        ViewDetails("\n$bAff", 0);
        ViewDetails("\n$bAff", 1);
        }
    else 
        { print $bAff; }
    
    #-- Entete du fichier --------------------------------------
    if ( !open(STAT, "> $NameCef.stat") ) {
        if ( $FlagIHM == 1 ) { ViewInfo("Warning", "Can't open for writing file \'$NameCef.stat\' !", 'red'); }
        else { print "\n\n   Can't open for writing file \'$NameCef.stat\' !\n\n"; }
        return -1;
        }
    $buf = "";
    @Fic = sort keys %Fichiers;
    $NbFic = $#Fic + 1;
    for $F ( @Fic ) {
        $FileName = $F;
        if ( $TypeAli ne '.ali' ) { $FileName =~ s/\.ali$//i; }
        $buf .= "\t$FileName";
        $SumLgr += $FicLen{$F};     # longueur totale de la concatenation
        }
    print STAT "#-----------------------------------------------------------------------\n";
    print STAT "# STATISTICS ABOUT CONCATENATION AND FUSION BY SCaFoS\n";
    print STAT "# In directory: $FileRep\n";
    print STAT "# Out directory: $CefRep\n";
    print STAT "# File of species: $SpecFile\n";
    print STAT "# Concatenation length: $SumLgr\n";
    print STAT "# File number: $NbFic\n";
    if ( $FlagNoPuz == 1 ) 
        { print STAT "# Selection of longest sequence\n"; }
    else { 
        print STAT "# Selection of less divergent sequence\n";
        print STAT "# Removing of divergent sequence > ". 100*$PctAve . "%\n";
        }
    if ( $FlagChim == 1 ) { print STAT "# Making of Chimera\n"; }
    if ( $FlagDef == 1 ) { print STAT "# Use of default sequences\n"; }
    print STAT "# Sequence length >= ". $MinLen ."%\n";
    print STAT "# Complete sequence >= ". (100-$MissPos) ."%\n";
    print STAT "# ".scalar(localtime(time()))." \n";
    print STAT "#-----------------------------------------------------------------------\n\n";   
    print STAT pack("A30", '') . $buf . "\t\% miss.poss\t\% miss.genes\t% chimera\n";
    
    #-- parcours du tableau par ligne = groupe -----------------
    @Grp = sort keys %hGrp;
    $NbGrp = $#Grp + 1;
    for $Grp ( @Grp ) {
        if ( $FlagVerb == 1 ) {
            if ( $FlagIHM == 1 ) { ViewDetails("\n    $Grp", 0); }
            else { print "\n    $Grp"; }
            }
        $buf = pack("A30",$Grp);
        #-- % de trous par groupe et par fichier --
        for $F ( @Fic ) {
            if ( $FicLen{$F} == 0 ) { next; }
            $trous = sprintf("%.0f", $hGrpFic{$F}{$Grp} * 100 / $FicLen{$F});
            $buf .= "\t" . $trous;
            }
        #-- statistiques par groupe pour l'ensemble de la concatenation --
        $buf .= "\t" . sprintf("%.0f", $hStatGrp{$Grp}[0] * 100 / $SumLgr);
        $buf .= "\t" . sprintf("%.0f", $hStatGrp{$Grp}[1] * 100 / $NbFic);
        $buf .= "\t" . sprintf("%.0f", $hStatGrp{$Grp}[2] * 100 / $NbFic);
        $buf .= "\n";
        print STAT $buf;
        }
       
    #-- statistiques par fichier -------------------------------
    if ( $FlagVerb == 1 ) {
        $bAff = "\n\n    Writing of global statistics by aligned file\n";
        if ( $FlagIHM == 1 ) { ViewDetails($bAff, 0); }
        else { print "$bAff"; }
        }
    @L = keys %hStatGrp;
    $NbGrp = $#L + 1;
    $b1 = "% missing positions           ";
    $b2 = "% missing OTUs              ";
    $b3 = "% chimeras                    ";
    $b4 = "sequence length               ";
    
    my $i;
    my @T1;
    for $F ( @Fic ) {
        if ( $FicLen{$F} == 0 ) 
            { $b1 = "\t"; $b2 = "\t"; $b3 = "\t"; }
        else {
            # % sites manquants par fichier
            if (  ($FlagMisSit == 1) and ($FlagVerb == 1) ) {    
                $bAff = "    === $F ===\n";
                if ( $FlagIHM == 1 ) { ViewDetails($bAff, 1); }
                else { print $bAff; }
                }
            $trous = sprintf("%.0f",@{$hStatFic{$F}}[0] * 100 / ($FicLen{$F} * $NbGrp));
            $b1 .= "\t$trous";
            if ( ($FlagMisSit == 1) and ($trous <= $PctMisSit) ) {
                if ( ($trous % $PasMisSit) > 0 ) { $trous = $PasMisSit * (int($trous/$PasMisSit)+1); }
                for ( $i = $trous; $i <= $PctMisSit; $i += $PasMisSit ) {
                    $L = $F;
                    if ( $TypeAli ne '.ali' ) { $L =~ s/\.ali$//i; }
                        if ( $^O eq 'linux' ) { system("cp -f $FileRep$SepDir$L $MisSitRep".$SepDir."missit_$i"); }
                        else { system("copy /Y $FileRep$SepDir$L $MisSitRep".$SepDir."missit_$i"); }
                    }
                }
            # % groupes manquants par fichier
            $trous = sprintf("%.0f", @{$hStatFic{$F}}[1] * 100 / $NbGrp);
            $b2 .= "\t$trous";
            # % chimeres par fichier
            $trous = sprintf("%.0f", @{$hStatFic{$F}}[2] * 100 / $NbGrp);
            $b3 .= "\t$trous";
            }
        $b4 .= ("\t" . $FicLen{$F});        
        }
    print STAT "$b1\n$b2\n$b3\n$b4\n";
    close STAT;

    if ( $FlagMisSit == 0 ) { return(); }
    
    ### Gestion des sous-repertoires par pourcentage de positions manquqntes ###
    if ( $FlagMisSit == 1 ) {
        if ( $FlagVerb == 1 ) {    
            $bAff = "\n=======================================================================\n";
            $bAff .= "\n SUB-DIRECTORIES ACCORDING TO MISSING SITES\n\n";
            }
        else
            { $bAff = "\n SUB-DIRECTORIES ACCORDING TO MISSING SITES\n"; }
####        if ( $FlagIHM == 1 ) { ViewDetails($bAff, 0); }
        if ( $FlagIHM == 1 ) { ViewDetails($bAff, 1); }
        else { print $bAff; }
        }
    
    #-- ecriture stat pour positions manquantes ---------------- 
    $NbFic = -1;
    my $NbPos;
    my $SumNbMis;
    my $SumNbPos;
    my $NbGrpMax;
    $buf = $MisSitRep.$SepDir."missit.stat";
    if ( !open(RES, "> $buf") )
        { AffError("\nCan\'t open \'$buf' (1)\n\n"); }
    print RES "#\tNo files\tNo sites\t% miss.sites\tNo OTUs\t\% miss.OTUs\n";
    
    #-- boucle sur les sous-repertoires ------------------------
    for ( $i = 0; $i <= $PctMisSit; $i += $PasMisSit ) {
        $buf = "$MisSitRep".$SepDir."missit_$i";
        if ( opendir(REP, $buf) ) {
            if ( $TypeAli eq '.ali' ) { @T1 = grep m/\.ali$/i, readdir REP; }
            elsif ( $TypeAli eq '.fasta' ) { @T1 = grep m/\.fasta$/i, readdir REP; }
            else { @T1 = grep m/\.phylip$/i, readdir REP; }
            closedir REP;
            #-- pas de nouveau fichier dans le repertoire : on supprime le repertoire ---
            if ( $#T1 == $NbFic ) {
                if ( $^O eq 'linux' ) { system("rm -fR $buf"); }
                else { system("rmdir /S /Q $buf"); }
                next;
                }
                
####            else {
            
            #-- entete fichier de statistiques ---
            if ( !open(STAT, "> $buf".$SepDir."missit_$i.stat") ) {
                if ( $FlagIHM == 1 ) { ViewInfo("Warning", "Can't open for writing file \'$buf/missit_$i.stat\' !", 'red'); }
                else { print "\n\n   Can't open for writing file \'$buf/missit_$i.stat\' !\n\n"; }
                return -1;
                }
            if ($FlagChim == 1 ) 
                { print STAT "#\tNo sites\t%miss.sites\tNo OTUs\t\%miss.OTUs\t%chim.\n"; }
            else
                { print STAT "#\tNo sites\t%miss.sites\tNo OTUs\t\%miss.OTUs\n"; }
            
            #-- initialise variables globales ---
            $NbFic = $#T1;                
            $SumNbMis = 0;
            $SumNbPos = 0;
            $NbGrpMax = 0;
            
            #-- boucle sur les fichiers du sous-repertoire :
            #   compte nombre de sites manquants, de groupes manquants 
            #   et de chimeres par fichiers --
            for $FileName ( @T1 ) {
                #-- statistiques sur le repertoire courant
                $F = $FileName;
                if ( $TypeAli ne '.ali' ) { $F .= ".ali"; }
                $NbGrp = $#Grp+1-$hStatFic{$F}[1];
                if ( $NbGrp > $NbGrpMax ) { $NbGrpMax = $NbGrp; }
                $NbPos = $NbGrp*$FicLen{$F};
                $SumNbPos += $NbPos;
                $SumNbMis += $hStatFic{$F}[0];
                $buf = "$FileName\t$NbPos\t" . sprintf("%.0f", $hStatFic{$F}[0]*100/$NbPos);
                $buf .= "\t$NbGrp\t" . sprintf("%.0f", $hStatFic{$F}[1]*100/$NbGrp);
                if ($FlagChim == 1 )
                    { $buf .= "\t" . $hStatFic{$F}[2] . "\n"; }
                else
                    { $buf .= "\n"; }
                print STAT $buf;
                }
            close STAT;
            
            #-- ecriture decompte final concatenation ---
            print RES "missit_$i\t".($NbFic+1)."\t$SumNbPos\t";
            print RES sprintf("%0.f", $SumNbMis*100/$SumNbPos);
            print RES "\t$NbGrpMax\t".sprintf("%0.f", ($#Grp+1-$NbGrpMax)*100/($#Grp+1));
            print RES "\n";
####                }
            }
        }
    close RES;
}


### Lecture du fichier .otu ####################################
sub ReadSpeToOrder {    
    my $L;
    my @T;
    
    if ( !open(SPE, $SpecFile) ) {
        if ( $FlagIHM == 1 ) { ViewInfo('Warning', "Can't open for reading the file \'$SpecFile\' !", 'red'); }
        else { print "   Can't open for reading the file \'$SpecFile\' !"; }
        return -1;
        }
    while ( $L = <SPE> ) {
        # passe lignes de commentaire
        $L =~ s/^\s+//;
        if ( $L =~ m/^#/ ) { next; }
        # separe nom du groupe des especes
        if ( $L =~ m/(.*):(.*)/ ) { 
            $L = $1;
####            $L =~ s/^\s//g;
####            $L =~ s/\s$//g;
            $L =~ s/^\s+//;
            $L =~ s/\s+$//;
            push @T, $L;
            }
        }
    close SPE;
    return (@T);
}


1;

### fin du fichier                                           ###
################################################################
